bool ana2011::GoodMuonJet(int imu,bool realData,bool smearMC,vector<int> indGoodMuon)
{
  if (indGoodMuon.size()!=0){
    for (unsigned int i = 0; i < indGoodMuon.size(); i++){
      int index = indGoodMuon.at(i);
      if (imu == index) return false;
    }
  }
  
  // ID
  if (mu_tight->at(imu) != 1)      return false;

  // Author
  if (mu_author->at(imu) != 12)     return false;
    
  //acceptance
  double eta = fabs(mu_eta->at(imu));  

  if (eta > 2.5)                    return false;

  //smear pt
  double pt = mu_pt->at(imu);
  double ptSmear = pt;
  if (!realData && smearMC){
    double ptme = sin(mu_me_theta->at(imu))/fabs(mu_me_qoverp->at(imu));
    double ptid = sin(mu_id_theta->at(imu))/fabs(mu_id_qoverp->at(imu));
    m_muPsmear->SetSeed(EventNumber,imu);
    m_muPsmear->Event(ptme,ptid,pt,eta); 
    ptSmear = m_muPsmear->pTCB();
  }
  
  if (ptSmear < 20e3)                return false;
  
  if (!(!mu_expectBLayerHit->at(imu) || mu_nBLHits->at(imu) > 0))
    return false;
  
  if ((mu_nPixHits->at(imu) + mu_nPixelDeadSensors->at(imu)) <= 1)
    return false;
  
  if ((mu_nSCTHits->at(imu) + mu_nSCTDeadSensors->at(imu)) < 6)
    return false;
  
  if ((mu_nPixHoles->at(imu)+ mu_nSCTHoles->at(imu)) >= 3)
    return false; 
  
  int n = mu_nTRTHits->at(imu) + mu_nTRTOutliers->at(imu);
  
  if (eta < 1.9){
    if (n <= 5 || float(mu_nTRTOutliers->at(imu))/n >= 0.9)
      return false;
  }
  else {
    if (n > 5) {
      if (float(mu_nTRTOutliers->at(imu))/n >= 0.9)
	return false; 
    }
  }
  
  return true;
}

std::vector<std::pair<TLorentzVector,TLorentzVector> > ana2011::AddMuonJet(bool realData,bool smearMC,std::vector<int> indGoodMuon) 
{

  std::vector<std::pair<TLorentzVector, TLorentzVector> > MuonJetPairs;
  for (unsigned int i = 0; i < mu_pt->size(); i++) {
    if (GoodMuonJet(i,realData,smearMC,indGoodMuon)){
      TLorentzVector v4m;
      v4m.SetPtEtaPhiM(mu_pt->at(i),mu_eta->at(i),mu_phi->at(i),0);
      
      for (int ij = 0; ij < jet_n; ij++) {
	TLorentzVector vjet;
	vjet.SetPtEtaPhiM(jet_pt->at(ij),jet_eta->at(ij),jet_phi->at(ij),jet_m->at(ij));
	double dRmujet = v4m.DeltaR(vjet);
	
	if (dRmujet < 0.4) {
	  MuonJetPairs.push_back(std::make_pair<TLorentzVector,TLorentzVector>(v4m,vjet));
	}
      }
    }
  }

  return MuonJetPairs;
}
    
