void GetRunNumberBranch(int); 
void GetSelBranch(int,int);

//Preselection
void InitMyTree();
bool AtLeastOneGoodPrimaryVertex(int);
bool OneLooseBadJet(double,double);
double VetoTrackJetInHole();
bool GoodElectron(int);
//bool GoodElectron(int,bool);
bool GoodMuon(int);
bool GoodMuonJet(int,bool,bool,vector<int>);//this function will be used to choose muon and add to jets
std::vector<std::pair<TLorentzVector,TLorentzVector> > AddMuonJet(bool,bool,std::vector<int>);
bool GoodJets(int);
bool MatchTrigger(int,vector<TLorentzVector>,vector<TLorentzVector>);
bool HypoEF(int);
FILE *EvtListC2;
FILE *EvtListC3;
FILE *EvtListC4;
FILE *EvtListC5;
FILE *EvtListC11;
FILE *EvtListC12;
FILE *EvtListC13;
//FILE *EvtListC14e;
//FILE *EvtListC14m;
std::ofstream EvtListC14e,EvtListC14m;

FILE *testptSEl1; 
FILE *testptSEl2; 
FILE *testptSMu1; 
FILE *testptSMu2; 

TH1F *hwSFb, *hwSFemu;

//Matching
std::pair<std::vector<int>, std::vector<TLorentzVector> > InitMatching(int, double);
pair<unsigned int, vector<TLorentzVector> > matchQstat2Jets(std::vector<Particle>, std::vector<Particle>, bool);
void TruthAna(double,vector<Particle>,vector<Particle>,bool,Particle,int,int,vector<TLorentzVector>,vector<TLorentzVector>,vector<TLorentzVector>,TLorentzVector,TLorentzVector,double,double,double);
void FillFlavourChi2(vector<TLorentzVector>,vector<Particle>,TLorentzVector,TLorentzVector,TLorentzVector,TLorentzVector);

void TagTop172(vector<Particle>,vector<TLorentzVector>,vector<TLorentzVector>,bool);
bool emuOverlap(vector<int>);
double SFemu(vector<TLorentzVector>,vector<TLorentzVector>,vector<int>);
double SFbtag(vector<int>);

egammaOQ myOQ;
MET_Cleaning_Utils MET_Util; 

//CaloIsoCorrection *m_checkIso; 
//PDFReweight * m_checkPDF;
Root::TPileupReweighting *m_PUrewei;
int iTestPdf, nMemTestPdf;
int iDefaultPdf, nMemDefaultPdf;

//Other tools, SF, smearing
egammaSFclass *m_eleSF;
double m_lepEffSF;
EnergyRescaler *m_eleEscalesmear;
SmearingClass *m_muPsmear;
Analysis::MuidCBScaleEffFactors *m_muSF;
Analysis::CalibrationDataInterfaceROOT *m_btagSF;
Analysis::CalibrationDataVariables m_aJetForSF;

//bool for tools
bool hasLArHole;
bool m_ApplyHoleVeto;
bool m_smearMC;
bool m_corrData;
bool UseTool1; 
bool UseTool2;
bool UseTool3;
bool UseTool4;
bool m_trigMu;

//to read the smeared pt
double m_ptElSm;
double m_ptMuSm;

//Efficiency with new weights

double m_weight1[100],
  m_weight2[100],
  m_weight3[100],
  m_weight4[100];
double m_weight12[100],
  m_weight22[100],
  m_weight32[100],
  m_weight42[100];

int Nevt[41];
TH1F *m_mjjBest, *m_mjjSecond;
TH1F *m_mjjBest4leadingjets;
TH1F *m_mjj1, *m_mjj2, *m_mjj3;

//Histos for truth informations
TH1F * m_pTttpairMC, *m_pTminmatch_pTmaxnotmatch;
TH1F * m_pTminmatch[2], *m_pTmaxnotmatch[2];

TH1F *m_mjetMax;
TH1F *m_category[2],
  *m_NotMatch[2],
  *m_MergedJet[2],
  *m_mtophadMatch[5],
  *m_chi2Match[5],
  *m_mtophadMatchGoodOrder,
  *m_mtophadMatchWrongOrder,
  *m_mtophadMatchWrongOrder1,
  *m_mtophadMatchWrongOrder2,
  *m_dRlep_MatchGoodOrder, 
  *m_dRlep_MatchWrongOrder, 
  *m_dRneu_MatchGoodOrder1,
  *m_dRneu_MatchWrongOrder1,
  *m_dRneu_MatchGoodOrder2,
  *m_dRneu_MatchWrongOrder2;
TH1F *m_dRWlepbenTruth[3], 
  *m_dRWhadbqqTruth[3], 
  *m_dRWlepben[3], 
  *m_dRWhadbqq[3];
TH2F *m_evt_mixjets;

TH1F *m_loose,//loose for all channels
  *m_looseE,//loose for e+jets channel 
  *m_looseM,//loose for mu+jets channel 
  *m_looseMuon, //loose in GoodMuon
  *m_looseEle;//loose in GoodElectron
TH1F *m_looseSig,
  *m_looseESig,
  *m_looseMSig;

//On 14March : look at the muon in the e channel
TH1F *m_ptmuon_echannel, *m_dRmu_goodjets_echannel, *m_ptmu_goodjets_echannel, *m_etamu_goodjets_echannel, *m_dRmu_notgoodjets_echannel, *m_ptmu_notgoodjets_echannel, * m_etamu_notgoodjets_echannel;
TH1F *m_dR2goodjets;
  
TH1F *m_njets, *m_njetsE, *m_njetsM, *m_njetsB, *m_njetsBE, *m_njetsBM, *m_loose_noGoodLepton, *m_allpdg3, *m_allpdg, *m_eta_aftercut_Ele, *m_pt_aftercut_Ele, *m_eta_aftercut_Muo, *m_pt_aftercut_Muo, *m_loose_category2;
TH2F *m_loose_2Dim;

//Histo for chi2bar analysis
TH1F *m_dmt[3],
  *m_dmmin[3],
  *m_weiSV0Max[3],
  *m_weiSV0SubMax[3];

TH1F *m_sv0[4];
TH1F *m_ip3dsv1[4];

//End of chi2BAR analysis
   
//Histo for chi2 analysis
TH1F *m_m2min_sWS[3],
  *m_m3min_sWS[3],
  *m_m2min_sWB[3],
  *m_m3min_sWB[3],
  *m_pTtttouschi2[3],
  *m_pTttpairchi2[3],
  *m_dmtchi2[3],
  *mtophad_grandchi2[3],
  *chi2histo[3],
  *chi2_second[3],
  *m_DeltaElep[3],
  *m_DeltaEqrk[3];
TProfile *m_dEqsurchi2[3],
  *m_dElsurchi2[3],
  *m_dmWsurchi2[3],
  *m_dmtsurchi2[3];
TH2F *m_twoDim_m2min_chi2min[3],
  *m_twoDim_m2min_pTttpairchi2[3],
  *m_twoDim_m2min_pTtophad[3],
  *m_dEdmW[3],
  *m_twoDim_mintmt_chi2[3],
  *m_twoDim_mtophad_chi2[3],
  *m_twoDim_mtophad_chi2fittop[3];    
//End of chi2 analysis

//################ ADD HISTOS TO FIND CUTS ##############
TH1F *m_mWhad[9],
  *m_mWlep[9],
  *m_mtophad[9],
  *m_mtoplep[9],
  *m_EWhad[9],
  *m_EWlep[9],
  *m_pTtophad[9],
  *m_pTtoplep[9],
  *m_pZtophad[9],
  *m_pZttbar[9],
  *m_pTttbar[9],
  *m_pTtophad_all[9],
  *m_sWSdis[9],
  *m_sWBdis[9],
  *m_PTleadingjet[9],
  *m_PTsubleadingjet[9],
  *m_HT[9],
  *m_sumptjets[9],
  *m_sumptjetsmu[9],
  *m_ET[9],
  *m_deltaeta1_el[9],
  *m_etajbqq[9],
  *m_etajq1W[9],
  *m_etajq2W[9],
  *m_etajben[9],
  *m_etaLep[9],
  *m_etaNeu[9],
  *m_etaMin[9],
  *m_etaMax[9],
  *m_ptjbqq[9],
  *m_ptjq1W[9],
  *m_ptjq2W[9],
  *m_ptjben[9],
  *m_ptLep[9],
  *m_ptNeu[9],
  *m_dRqqW[9],
  *m_dRmin_eq[9],
  *m_MET[9],
  *m_phiMET[9],
  *m_MTlepneu[9],
  *m_dphiminMETjet[9],
  *m_dRlepjet[9],
  *m_pTWlep[9],
  *m_sphericity[9],
  *m_sphericityT[9],
  *m_aplanarity[9],
  *m_mjjj[9],
  *m_dRWhadj[9],
  *m_pTWhad[9],
  *m_mlepjet[9],
  *m_nGoodJets[9];
     
TH2F *m_twoDim_HT_mjjj[9],
  *m_sWBdis_sWSdis[9],
  *m_deltaM_pTtop_deltaMmin[9],   
  * m_Th1_Th2[9];

//Declare trees
TFile *file;
TTree *tree_ana;
Int_t b_EventNumber_ana,
  b_RunNumber_ana,
  b_hfor,
  b_hasBadJet,
  b_isEleEvent,
  b_nMatchedJetInGoodJets, 
  b_nMatchedJetInChi2,
  b_Njet,
  b_LeadingJetsInChi2,
  b_catAll,     
  b_catChi2,
  b_flavjbqq,
  b_flavjq1W,
  b_flavjq2W,
  b_flavjben,
  b_NRealbChi2;

Double_t b_dsigmaGG, b_dsigmaQQ, b_dsigmatot,
  b_chi2minmin, b_chi2second, b_chi2New,
  b_WeiEvent,
  b_hasLArHole,
  b_ApplyHoleVeto, 
  b_UseTool1,      
  b_UseTool2,      
  b_UseTool3,      
  b_UseTool4,      
  b_smearMC,       
  b_corrData,      
  b_mcevt, 
  b_PUwei, 
  b_SFemu, 
  b_SFbtag,
  b_lbn_ana,
  b_Th1,
  b_Th2,
  b_HT,
  b_sumptjets,
  b_sumptjetsmu,
  b_ET,
  b_MET,
  b_phiMET,
  b_PTsubleadingjet,
  b_PTleadingjet,
  b_MTlepneu,
  b_dphiminMETjet,
  b_pTWlep,
  b_mjjj,
  b_dRWhadj,
  b_pTWhad,
  b_mlepjet,
  b_mtophad,
  b_mtoplep,
  b_EWhad,
  b_EWlep,
  b_MbqqWhad,
  b_MbenWhad,
  b_MbqqWlep,
  b_MbenWlep,
  b_pTtophad,
  b_pTtoplep,
  b_pZtophad,
  b_pZttbar,
  b_pTttbar,
  b_etajbqq,
  b_etajq1W,
  b_etajq2W,
  b_etajben,
  b_phijbqq,
  b_phijq1W,
  b_phijq2W,
  b_phijben,
  b_etaLep,
  b_phiLep,
  b_etaNeu,
  b_etaMin,
  b_etaMax,
  b_ptjbqq,
  b_ptjq1W,
  b_ptjq2W,
  b_ptjben,
  b_ptLep,
  b_ptNeu,
  b_dRqqW,
  b_dRmin_eq,
  b_ctet_qtlep,
  b_cos_q1CMw_topboost,
  b_cos_q2CMw_topboost,
  b_cos_lepCMw,
  b_cos_bWenCMt,
  b_cos_lepCMt,
  b_cos_bneuCMt,
  b_cosWqq,
  b_cosWen,
  b_cosqW1,
  b_cosqW2,
  b_PWqq,
  b_PWen,
  b_P_thad,
  b_P_tlep,
  b_costpair_lab,
  b_dRminbNeu,
  b_dRminbhadWqq,
  b_dRminblepWqq,
  b_dRbb,
  b_dRminNeuWqq,
  b_cos_tlepCMtpair,
  b_ptWqq,
  b_ptWen,
  b_mjetMax,               
  b_mtophadMatchGoodOrder, 
  b_mtophadMatchWrongOrder,
  b_mWfit,
  b_mWBest,
  b_EbqqTruth,     
  b_Eq1WTruth,	
  b_Eq2WTruth,	
  b_EbenTruth,	
  b_ElepTruth,	
  b_EneuTruth,	
  b_bqqTruthX,	
  b_bqqTruthY,	
  b_bqqTruthZ,	
  b_benTruthX,	
  b_benTruthY,	
  b_benTruthZ,	
  b_q1WTruthX,	
  b_q1WTruthY,	
  b_q1WTruthZ,	
  b_q2WTruthX,	
  b_q2WTruthY,	
  b_q2WTruthZ,	
  b_lepTruthX,	
  b_lepTruthY,	
  b_lepTruthZ,	
  b_neuTruthX,	
  b_neuTruthY,	
  b_neuTruthZ,	
  b_bqqChi2X,      
  b_bqqChi2Y,	
  b_bqqChi2Z,	
  b_benChi2X,	
  b_benChi2Y,	
  b_benChi2Z,	
  b_q1WChi2X,	
  b_q1WChi2Y,	
  b_q1WChi2Z,	
  b_q2WChi2X,	
  b_q2WChi2Y,	
  b_q2WChi2Z,	
  b_lepChi2X,	
  b_lepChi2Y,	
  b_lepChi2Z,	
  b_neuChi2X,	
  b_neuChi2Y,	
  b_neuChi2Z,	
  b_EbqqChi2,	
  b_Eq1WChi2,	
  b_Eq2WChi2,	
  b_EbenChi2,	
  b_ElepChi2,	
  b_EneuChi2,
  b_E1nofit,
  b_E2nofit,
  b_E3nofit,
  b_E4nofit,
  b_E5nofit,
  b_E1fit,  
  b_E2fit,  
  b_E3fit,  
  b_E4fit,  
  b_E5fit,  	
  b_dRWhadbqqTruth,
  b_dRWlepbenTruth,
  b_dRWhadbenTruth,
  b_dRWlepbqqTruth,
  b_MinAbsMtophadMtop,
  b_MinAbsMtoplepMtop,
  b_MinMtophadMtop,   
  b_MinMtoplepMtop,
  b_MinAbsLep1,
  b_MinLep1,    
  b_MinAbsHad1, 
  b_MinHad1,    
  b_MinAbsLep2, 
  b_MinLep2,    
  b_MinAbsHad2, 
  b_MinHad2,
  b_pTMinLep1,
  b_pTMinHad1,
  b_PtElLost, 
  b_EtaElLost,
  b_IsoElLost, 
  b_ElLostIsMedium,
  b_ElLostIsTight, 
  b_PtMuLost, 
  b_EtaMuLost,
  b_ptMinQuark,
  b_mMinQuark,
  b_etaMaxQuark,
  b_etaMaxQuarkW,
  b_dRqqWstat3;

TH1F *m_x1[9], *m_x2[9], *m_dsigmaQQ[9], *m_dsigmaGG[9], *m_dsigmatot[9];
   
TH1F *m_yplus[9],
  *m_yminus[9],
  *m_pTtop[9],
  *m_ctet_qtlep[9],
  *m_cos_lepCMw[9],
  *m_cos_lepCMt[9],
  *m_cos_q1CMw_topboost[9],
  *m_cos_q2CMw_topboost[9],
  *m_cos_bWenCMt[9],
  *m_cos_bneuCMt[9],
  *m_cosWqq[9],
  *m_cosWen[9],
  *m_cosqW1[9],
  *m_cosqW2[9],
  *m_PWqq[9],
  *m_PWen[9],
  *m_P_thad[9],
  *m_P_tlep[9],
  *m_costpair_lab[9],
  *m_dRminbNeu[9],
  *m_dRminbhadWqq[9],
  *m_dRminblepWqq[9],
  *m_dRbb[9],
  *m_dRminNeuWqq[9],
  *m_cos_tlepCMtpair[9],
  *m_ptWqq[9],
  *m_ptWen[9];

TH2F *m_yplus_yminus[9],
  *m_pTtop_dsigma[9];

TH1F *m_CutCat[9];

TH1F *m_cosWqqNEW[27], *m_mtophadNEW[27];

TH1F *m_dchi2New_chi2second, *m_dchi2New_chi2minmin, *m_ptMaxRest_3jetsfound, *m_etaMaxRest_3jetsfound, *m_ptMaxRest_4jetsfound, *m_etaMaxRest_4jetsfound;
TH2F *m_ptMaxRest_pTttbar, *m_ptMaxRest_pTttbar_3jetsfound, *m_ptMaxRest_pTttbar_4jetsfound, *  m_chi2_pTttbar, *m_dchi2_pTttbar, *m_chi2minmin_pTttbar_3jetsfound, *m_chi2minmin_pTttbar_4jetsfound;
TH1F *m_ptMatchedJetNotInChi2, *m_ptMinJetInChi2;
TH1F *m_mtophadMatchedPars, *m_mtoplepMatchedPars, *m_dchi2Matched_chi2minmin, *m_dchi2Matched_chi2second;
TH1F *m_mtophad_00, *m_mtophad_01, *m_mtophad_10, *m_mtophad_11;
TH2F *m_twoDim_mjjj_HT_00, *m_twoDim_mjjj_HT_10, *m_twoDim_mjjj_HT_01, *m_twoDim_mjjj_HT_11; 

TH1F *m_mWfit;

TH2F *m_twoDim_Logdsigma_HT, *m_twoDim_Logdsigma_HT_nasty;

TH2F *m_twoDim_MinMtophadMtop_MinMtoplepMtop;
TH1F *m_MinAbsMtophadMtop, *m_MinAbsMtoplepMtop;

//Counters
int iEvtSel;
int m_nall;
int n6DifPartons;
int m_NAllFit;
int nHyperNasty;
int nHasJetInHole;

int iEE;
int iEM;
int iMM;
int iLQ;
int n2ndMu;
int n2ndEl;

TH1F *hEpt  ;
TH1F *hMpt  ;
TH1F *hEeta ;
TH1F *hMeta ;

TH1F *m_lbn, *m_PUwei, *m_lbnW;
TH1F *m_hfor[2];
